;***********************************************************;
;*             (C) Barrett Technology Inc.                 *;
;*             139 Main Street                             *;
;*             Cambridge, MA 02142, USA                    *;
;*             Version 3.0        1995                     *;
;*             Author: Daniel Griscom                      *;
;***********************************************************;

;* File: assembly.h.
;	This file has two interrupt-related assembly code functions.

; Interrupt get and set.

	.public _intGet
	.public _intSet

; intGet returns 0 if interrupts are enabled, 1 if they are not.
_intGet:
	tpa
	anda    #10H
	beq     1$
	ldd     #00
	bra     1$
1$:     
	ldd     #1
2$:     
	rts		; Need two RTSs, since the linker seems to trim off one. (?)
	rts

; intSet enables interrupts if its argument is 0, disables them if not.
_intSet:
	tsta
	bne     1$
	tstb
	beq     2$
1$:     
	cli
	bra     3$
2$:     
	sei
3$:     
	rts
	rts

	.end
