/***********************************************************/
/*             (C) Barrett Technology Inc.                 */
/*             139 Main Street                             */
/*             Cambridge, MA 02142, USA                    */
/*             Version 4.0        1998                     */
/*             Author: Daniel Griscom                      */
/*             		   Suitable Systems                    */
/*             		   griscom@suitable.com                */
/*             		   www.suitable.com                    */
/***********************************************************/

/* File: bhand.h
	This contains all the global definitions for the hand software. */

/*      Note: you'll see "#ifdef __MWERKS__" at various places in the code.
	I'm using MetroWerks C on my Macintosh to do syntax checking. The
	compiler is slightly different from the Whitesmith C used at Barrett;
	the differences are compensated for by using these #ifdef statements. */

/*      Note: by convention, I've marked all locations in the source code that may
	need examination with at least four question marks in a row ("????"). I've
	also marked all locations that WILL need examination by four exclamation
	points in a row ("!!!!"). Do a global search for each before final shipment. */

#ifndef _bhand_h
#define _bhand_h

#define true (1)
#define false (0)
#define EOF (-1)
#define NULL 0

/* Getting and setting bytes and words */
#define peekb(addr)        (*(char *)(addr))
#define peek(addr)         (*(int  *)(addr))
#define pokeb(addr, ch)    ((*(char *)(addr)) = (unsigned char)(ch));
#define poke(addr, vint)   ((*(int  *)(addr)) = (vint));

/* These turn debugging statements on and off. */
#define D(x) 
#define D1(x) 
#define D2(x) 
#define D4(x) 
#define D5(x) 
#define D6(x) 
/* The various D3s are used in motor.c. */
#define D3(x) 
#define D3A(x) 

/* voidFuncVoidPtr is a pointer to a routine that takes no parameters and
	returns no result. */
typedef void (*voidFuncVoidPtr)(void);
/* intFuncVoidPtr is a pointer to a routine that takes no parameters and
	returns an integer. */
typedef int (*intFuncVoidPtr)(void);

/* If we're using the MetroWerks C compiler for the Mac (for syntax checking
	and general tool availability), vacuously simulate some keywords. */
#ifdef __MWERKS__

#define _asm(x) 0               /* in-line assembly */
#define eepcpy(x, y, z) 0       /* EEPROM functions */
int strcmp(char *s1, char *s2); /* string library */
void memcpy(void *s1, void *s2, int count); /* memory copy */
long atol(char *s);             /* string library (again...) */
#define const					/* Disable the damn thing... */


#endif /* #ifdef __MWERKS__ */

#include "assembly.h"

#include <stdio.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>

#endif /* #ifndef _bhand_h */
