#	COSMIC C 3.6i ENVIRONMENT PROTOTYPE FILE
#	CXDOS86 MC68HC11 -- MS/PC-DOS Cross to MC68HC11
#	Programmable flag options:
#
#	alu	: use arithmetic unit for N/M versions
#	c0	: produce C0 style bank switching code
#	dl1	: produce line number information (type 1)
#	dl2	: produce line number information (type 2)
#	fast	: use fast function entry
#	float	: use floating point library
#	lincl	: include header files in listing or diagnostic output
#	listc	: create c listing with errors in (r).lst
#	listcs	: create c/assembler listing in (r).ls
#	map	: create a map from the linker in (r).map
#	mice	: debug code for mice emulator
#	noopt	: disable post optimizer
#	nobss	: do not use bss
#	nostrict: allow more lenient type checking
#	nowiden	: do not widen arguments
#	prom    : enable automatic data initialization
#	rev	: reverse bitfield ordering
#	savlnk	: save linker input file as (r).lnk
#	sprec	: use float library instead of double
#	st1	: static model 1
#	st2	: static model 2
#	st3	: static model 3
#	st4	: static model 4
#	std	: force the input to conform to ANSI C draft standard
#	strict	: enforce more stronger type checking
#	verbose	: display information on p2 activities
#	xdbg	: produce debug info for 3.32 compatibility
#	xdebug	: produce all debugging information for CXDB
#	zpage	: force data in zpage

c:cpph11	-o (o) {xdebug?+xdebug:{lincl?+lincl}} -x -i "|c:/c/hdrsh11/" \
		{std?+std} {listcs?-err} {listc?-err} -n127 \
		{zpage?"c:/c/hdrsh11/zpage.h"} \
		{fast?"c:/c/hdrsh11/fast.h"} \
		(i)

1:cp1h11	-o (o) -mu -b0 -n127 {std?+std} {rev?-rev} \
		{dl1?-dl:{dl2?-dl}} \
		{xdebug?+xdebug +xref:{xdbg?+xdebug +xenum}} \
		{strict?+strict:{nostrict?-strict}} \
		{listc?-err} {nowiden?+nwd} {sprec?-f} \
		(i) \
		{listc?>ctempc.err}

 {listc?echo \#error cp1(V3.60) (r).c\:0 >> ctempc.err}
 {listc?lm	-o (r).lst -err -flt ctempc.err}
 {listc?del	ctempc.err}

2:cp2h11	-o (o) {nobss?-bss} {listcs?+list} \
		{st1?-st1:{st2?-st2:{st3?-st3:{st4?-st4}}}} \
		{dl1?-dl1:{dl2?-dl2}} {c0?-tc} \
		{verbose?-v} {noopt?-no} {alu?-alu} \
		(i)

3:{noopt?copy (i) (o) >nul:opth11 -o (o) {verbose?-cv} (i)}

 {listcs?lm	-o ctempc.tmp -err -lt -c "; " (o)}
 {listcs?del	(o)}
 {listcs?ren	ctempc.tmp (o)}

s:x6811		-o (o) -i "|c:/c/lib/" {alu?-dalu=1} {listcs?+l (r)} (i)

o::echo		+h -o (o) {map?+map=(r).map} +zpage -m256 > (r).lnk
 echo		+text -b0xe000 +data -b0x2000 \
		c:/c/lib/crts{prom?i}.h11 (i) {mice?+def =i_cxdb} >> (r).lnk
 echo		{sprec?"c:/c/lib/libf"{alu?a}.h11:\
		{float?"c:/c/lib/libd"{alu?a}.h11}} \
 		c:/c/lib/libi{alu?a}.h11 c:/c/lib/libm.h11 >> (r).lnk
 echo		+def __memory=__bss__ {prom?+def __pdata=__text__} >> (r).lnk
 lnkh11 < (r).lnk
 {prom?toprom	-o ctempc.prm (o)}
 {prom?del	(o)}
 {prom?ren	ctempc.prm (o)}
 {savlnk?:del	(r).lnk}
h11:
