/***********************************************************/
/*             (C) Barrett Technology Inc.                 */
/*             545 Concord Avenue                          */
/*             Cambridge, MA 02138, USA                    */
/*             Version 2.2        1994                     */
/*             Author: Jie Ren                             */
/***********************************************************/

/******* system definition ***************/
/*
#define ADCTL  	 0x1030
#define ADR1	 0x1031
#define ADR2	 0x1032
#define ADR3	 0x1033
#define ADR4	 0x1034
#define MYOPTION	0x1039
*/

/* all defines are in bar.asm */
#define FLAGS		0x00
#define PROGRAM 	0x05
#define STATUS		0x07
#define CTRL_MODE	0x03
#define COMMAND		0x08
#define PWM		0x09

#define RING		0x18
#define OFFSET		0x1C
#define PHASE		0x19
#define M_PHASE 	0x1F
#define X		0x1A
#define Y		0x1B

#define ACPOS		0x12
#define FINPOS		0x29
#define COMPOS		0x0C
#define SETPOS		0x15

#define SAMPLE		0x0F		/* sample time */
#define VELLSB		0x34		/* actual velocity, counts/sample */
#define VELMSB		0x35
#define CVELLSB		0x23		/* command velocity */
#define CVELMSB		0x24

#define SET_ALIGN	0x02
#define GAINK		0x22
#define POLE		0x21
#define ZERO		0x20
#define ACCEL		0x26		/* acceleration */
#define MAX_VEL		0x28
  
	/* clear all mode flags*/
#define HP_clrFlags() HP_write(FLAGS, 0x00); HP_write(FLAGS, 0x02); HP_write(FLAGS, 0x03); HP_write(FLAGS, 0x04); HP_write(FLAGS, 0x05);

#define readCmdPos() Pos.s.lst = HP_read(COMPOS+2); /*LST*/ Pos.s.mid = HP_read(COMPOS+1); Pos.s.mst = HP_read(COMPOS);
#define setCmdPos() HP_write(COMPOS,Pos.s.mst);  /*MSB*/ HP_write(COMPOS+1,Pos.s.mid); HP_write(COMPOS+2,Pos.s.lst);
#define readActPos() Pos.s.lst = HP_read(ACPOS+2);  /*LSB*/ Pos.s.mid = HP_read(ACPOS+1); Pos.s.mst = HP_read(ACPOS); 
#define setActPos()  HP_write(ACPOS,Pos.s.mst); HP_write(ACPOS+1, Pos.s.mid); HP_write(ACPOS+2, Pos.s.lst);                
#define setFinPos()  HP_write(FINPOS+2,Pos.s.mst);  /*MSB*/ HP_write(FINPOS+1,Pos.s.mid); HP_write(FINPOS,Pos.s.lst);                                      
#define HP_clrFlag035() HP_write(FLAGS, 0x00); HP_write(FLAGS, 0x03); HP_write(FLAGS, 0x05);
#define setProVel() HP_write(CVELLSB, Vel.s.lst); HP_write(CVELMSB, Vel.s.mst)
