/***********************************************************/
/*             (C) Barrett Technology Inc.                 */
/*             139 Main Street                             */
/*             Cambridge, MA 02142, USA                    */
/*             Version 4.0        1998                     */
/*             Author: Daniel Griscom                      */
/*             		   Suitable Systems                    */
/*             		   griscom@suitable.com                */
/*             		   www.suitable.com                    */
/***********************************************************/

/* File: line.h
	This contains all the line collection and word recognition
	routines. */

#ifndef _line_h
#define _line_h

#define bufLen (128)
#define maxWords (bufLen/2)

/* lineInit initializes the line handling code. */
void lineInit(void);

/* lineCollect collects characters into the line buffer until a
	line has been read, or there are no more characters. */
void lineCollect(void);

/* lineDone returns true iff a complete line has been read. */
int lineDone(void);

/* lineWordCount returns the number of words in the current line. ONLY call
	if lineDone returns true. */
int lineWordCount(void);

/* lineWordGet returns a pointer to the given null-terminated word.
	Word numbers are 0-based. ONLY call if lineDone returns true. */
char *lineWordGet(int wordNum);

/* lineClear clears the current line. */
void lineClear(void);

#endif /* #ifndef _line_h */
