/***********************************************************/
/*             (C) Barrett Technology Inc.                 */
/*             545 Concord Avenue                          */
/*             Cambridge, MA 02138, USA                    */
/*             Version 2.2        1994                     */
/*             Author: Jie Ren                             */
/***********************************************************/
/* position.c */

#include <stdio.h>
#include "bhand.h"
#include "hpdef.h"

/****************************************************
  Monitoring  Position etc. (DBO).
 ***************************************************/
void moni_position_HP()
{
        int vel, gaink, flags, status;
        unsigned int cmdtor;
	int midx;
        
        copReset();

        Ctrl.curtmtr = Ctrl.curtfngr; /* BUG !!*/
        /*D(printf( "\n Pos: ");)*/
        printf( "\n Pos: ");
   for (midx=1; midx <=4; midx++) {
   	
        copReset();
        slctMotor(midx);
        readActPos();	
        flags  = HP_read(FLAGS);
        status = HP_read(STATUS);        
        copReset();
	
        /*D(printf( " %06lx ", Pos.plong);)*/
	printf(" %02x%02x%02x ", Pos.s.mst, Pos.s.mid, Pos.s.lst ); /* Pos.plong);*/
        /*
        printf( " %06lx ", Pos.plong);        
        */
   }
        copReset();     /* read command position */       
        readCmdPos();   /* to Pos (structure) */
   
        cmdtor = HP_read(COMMAND);        
        copReset();
        delay(100);
}

#ifdef OLD
void moni_position_HP()
{
        int vel, gaink, flags, status;
        unsigned int cmdtor;

        copReset();

        Ctrl.curtmtr = Ctrl.curtfngr; /* BUG !!*/
        slctMotor(Ctrl.curtmtr);

        /*get_actualPos_HP();*/

        readActPos();
        /* Unkown BUG !!! */
        /*gaink  = HP_read(GAINK); Reading this continously will set gain to 12*/

        flags  = HP_read(FLAGS);
        status = HP_read(STATUS);

        D(printf( "\n M=%d  flag=%2x sta=%2x",  Ctrl.curtmtr, flags, status);)
        D(printf( " K=%2x ", gaink);)
        D(printf( " LPos: %06lx ", Pos.plong);)

        copReset();     /* read command position */
        readCmdPos();   /* to Pos (structure) */

        cmdtor = HP_read(COMMAND);        
        D(printf( " c=%5d T=%4d ", Pos.plong & 0xFFFFFF, cmdtor);)
        D(printf( " W=%5d ", HP_read(PWM));)

#ifdef LATER
        copReset();
        vel = HP_read(VELMSB)*256 + HP_read(VELLSB);
        printOnoff( " V=%5d ", vel);
        vel = HP_read(CVELMSB)*256 + HP_read(CVELLSB);        
        vel = vel >> 4;    /* 4 bit fraction */
        printOnoff( " C=%5d ", vel);        
#endif /*LATER*/

        copReset();
        delay(100);
}
#endif /*OLD*/

/****************************************************
  Clear commanded and actual Position to 0
 ****************************************************/
void  clr_position_HP()
{
        Pos.plong = 0L;
        setCmdPos();	/* from Pos (structure) */
        setActPos();	/* from Pos (structure) */

}


/****************************************************
   Set controller in idle mode (write 1 to PGM)
 ***************************************************/
void HP_idle()
{
        D(printf( "\n Motor %d idle.", Ctrl.curtmtr);)
        HP_write(PROGRAM, 0x01);
}


/****************************************************
  Test if vel is zero. 
  returns - 0x00 if it is true,
          - 0xFF if it is false.
 ***************************************************/
int HP_is_vel_zero()
{
        int a;
        a = HP_read(0x35);
        if ( a == 0 ) return 0;
        else return 0xFF;
}


