/***********************************************************/
/*             (C) Barrett Technology Inc.                 */
/*             545 Concord Avenue                          */
/*             Cambridge, MA 02138, USA                    */
/*             Version 2.2        1994                     */
/*             Author: Jie Ren                             */
/***********************************************************/
/* setmotor.c */
#include <stdio.h>
#include "bhand.h"
#include "hpdef.h"


/* set the curmotor as the active motor */
/* curmotor = 1 (0xF000), 2 (0xF010), 3 (0xF020), 4 (0xF030) */
void slctMotor( int curmotor)
{
        sei();

        Ctrl.curtmtr = curmotor;
        curmotor = (((curmotor-1) & 0x03) << 4 ) + 0xF000;

        /* for the new hardware design by Clive. 9/5/94 */
        Ctrl.CS =  curmotor+2;
        Ctrl.OE =  curmotor+1;
        Ctrl.ALE = curmotor;                

        cli();
}

/* align the current selected motor */
int alignCrntMotor( )
{
        int flg;
        int count;

        HP_clrFlags();          /* clear all flags */

        D(printf( "\n     Begin Alignment for Motor %d ... ", Ctrl.curtmtr);)
        clr_position_HP();        /* clr commanded and actual position regs*/

        HP_write(PROGRAM, SET_ALIGN);
        copReset();        

        count = 0;
        while(count < 550 ) {       /* until motor is idle */
                flg = HP_read(FLAGS);        
                if ( flg & 0x10 ) {
                        D(printf( " Done! ");
                        )
                                return 0;                          
                } 
                else copReset();
                count++;
        }
        D(printf( " F.");)
}

#ifdef LATER
        readFilter_HP()
        {
                int gain, zero, pole, accel,  maxvel;

                HP_write(GAINK, 0x22);
                HP_write(POLE,  0x21);
                HP_write(ZERO,  0x20);
                HP_write(ACCEL, 0x3F);
                /*HP_write(MAX_VEL, 0x28); */

                gain = HP_read(GAINK);
                pole = HP_read(POLE);
                zero = HP_read(ZERO);
                accel = HP_read(ACCEL);
                maxvel = HP_read(MAX_VEL);

                printf( "\n GainK=%x Pole=%x, Zero=0x%x, a=%x maxV=%x ",
                gain, pole, zero, accel, maxvel);                
        }                
#endif /*LATER*/        

