/***********************************************************/
/*             (C) Barrett Technology Inc.                 */
/*             139 Main Street                             */
/*             Cambridge, MA 02142, USA                    */
/*             Version 4.0        1998                     */
/*             Author: Daniel Griscom                      */
/*             		   Suitable Systems                    */
/*             		   griscom@suitable.com                */
/*             		   www.suitable.com                    */
/***********************************************************/

/* File: temp.h
	This code deals with reading the Dallas Semiconductor
	DS1602	temperature sensor. Note that the data line is on the
	portD bit 2, the clock line is on port D bit 3,	and the
	reset line is on port D	bit 4. */

#ifndef _temp_h
#define _temp_h

/* This	initializes the	temperature sensor.. */
void tempInit(void);

/* This	fetches	the temperature	as a signed integer in tenths of
	 a degree C. Min value -550; max value 1250.
	Resultion is actually a	half a degree. Argument is ignored. */
unsigned int tempRead(int garbage);

#endif /* #ifndef _temp_h */
