/***********************************************************/
/*             Barrett Technology Inc.                     */
/*             139 Main Street                             */
/*             Cambridge, MA 02139, USA                    */
/*             (C) Jie Ren  1994-1995                      */
/***********************************************************/
/* util.c */

#include <stdio.h>
/*#include <io.h>*/
#include "bhand.h"
#include "hpdef.h"

/* enable DA convertor */
void enableDA()
{                                                                        
        /* enable charge pump; */
        /* slow down the copreset timer */
        /* (~2 seconds for a 4.0Mhz cryster).*/
        /* CSEL not set */
        OPTION = 0x93;
        /* set mult and scan for 2nd group A/D */
        ADCTL = 0x34;
}        

void copReset()  
{
        COPRST = 0x55; 
        COPRST = 0xAA; /* reset watchdog */
}


/*  controlled by flag Printonoff
        Printonoff = 0     no printout
        Printonoff = 1     printout
*/
#ifdef LATER
int printOnoff(char *fmt, ...)
{
        char  buf[100];
        va_list arg_ptr;
        int count;

        if ( !Printonoff ) return 0;

        /* "arg_ptr" points format string */
        va_start(arg_ptr,fmt);

        count = vsprintf(buf, fmt, arg_ptr);
        va_end(arg_ptr);

        printf("%s", buf);

        return(count);
}
#endif /*LATER*/


void HP_write(int addrHp, int data)
{
        pokeb(Ctrl.ALE, addrHp);
        pokeb(Ctrl.CS, data);

}


/* read from the HP registor */
int HP_read(int addrHp)
{
        pokeb(Ctrl.ALE, addrHp);
        pokeb(Ctrl.CS, 0x0);     
        return peekb(Ctrl.OE);
}

/* get a string from keyboard (ended by a cariage return*/
/* the string is terminated by a null character */
/* returns the number of characters taken (excluding null characer)*/
int getAstring(char *buff)
{
        int i = 0, cc;
        while(1) {
                cc = getAchar();
                if ( cc == CR ) break;
                else if ( cc < '0' || cc > '9') {                 
                        printOnoff( "\n\t Invalid input, enter again: ");
                        i =0;
                } 
                else buff[i++] = cc;
        }
        buff[i] = '\0';
        return i;
}        


/* Written by M. Taylor */
/* Delays ms milliseconds running on a HC11 with a 8MHz x-tal */
/* and a timer pre-scale of 16 */
void delay( unsigned int ms )
{
        unsigned int temp;
        unsigned int time;
        for(temp=0; temp<ms; temp++) {
                time= TCNT;  /* read 16-bit timer count*/
                time+=125;   /* counter in one ms at 8MHz */
                TOC4 = time; /* time output compare */
                while( !(TFLG1 & 0x10) ) {
                } 
                TFLG1 = 0x10;
        }	
}


static curbaud = 0x21;
int readBaudrate()
{
        int i;
        for (i=0; i < TOTAL_BAUD; i++ ) {
                if ( Baud[i].rate == curbaud) return i;
        }        
        return -1;
}
